<?php
/**
*	class for the sortable list ajax - updated!!!
*
*	@author Peter Rehm < code [at] peter-rehm [dot] de > - <a href="http://peter-rehm.de">http://peter-rehm.de</a>
*	
*	A special thanks goes here to Tom Westcott, <a href="http://www.cyberdummy.co.uk/2005/07/23/javascript-slider-bar-uses-ajax/">cyberdummy.co.uk</a>
*	I needed the code to implement the very nice drag and drop feature into
*	'dycos' my new cms which is currently in development.
*
*	if you have suggestions, or fixes, dont hesitate to contact me.
*	if you change this code, please make it public and give me a note.
*
*	documentation
*
*	- create an class based on the sajax class which has the properties and methods you need for your environment
*	- instantiate an the sajax class with the wanted listelements ($sajax=new MySajax('menu1,menu2,menu3');)
*	- make sure that an database connection is established and the update functions is setted properly.
	  by default it is using an already open mysql connection with the information from the db array
*	- now you can easily create the output as you want to have it, with the db handler you like
*
*	news
*
*	>> i decided not to automize the output due the many possibilites in displaying the lists
*
*	>> with using the customized class you are fully flexible. i did this to open the possibility to customize it without changing the main class
*
*	>> while initiating the class you can now give the lists you want to have
*
*	todo
*
*	>> nothing known yet... im happy with it right now..
*
*/
class sajax
{
	
	/**
	*	sajax debug medode
	*/
	var	$sajax_debug_mode = 0;
	
	/**
	*	sajay export list
	*/
	var $sajax_export_list = array();
	
	/**
	*	sajax request type
	*/
	var $sajax_request_type = "GET";
	
	/**
	*	sajax remote uri
	*/
	var $sajax_remote_uri = "";
	
	/**
	*	reuqest uri
	*/
	var	$sajax_remote_uri;
	
	/**
	*	sajax js already shown?
	*/
	var $sajax_js_has_been_shown = 0;
	
	/**
	*	sajax path
	*/
	var $sajax_path='';
	
	/**
	*	sajax lists
	*/
	var $lists='menu1,hidden,menu2';

	/**
	*	database settings
	*/
	var $db=array('table'=>'',
				  'idfield'=>'',
				  'sidebarfield'=>'',
				  'orderfield'=>'');

	/**
	*	constructor for the initial things
	*/
	function sajax($lists='')
	{
	
		if(!empty($lists))
		{
			$this->lists=strip_tags($lists);
		}
		
		if(empty($this->lists))
		{
			die('error occured - no lists specified.');
		}
		
		$this->sajax_remote_uri = $_SERVER['REQUEST_URI'];
	
		$this->sajax_export("sajax_update");
		$this->sajax_handle_client_request();

		$header='
		<link rel="stylesheet" href="'.$this->sajax_path.'style/lists.css" type="text/css">
		<script language="JavaScript" type="text/javascript" src="'.$this->sajax_path.'js/drag.js"></script>
		<script language="JavaScript" type="text/javascript"><!--
		'.$this->sajax_get_javascript()."\n
		".$this->addOnloadEvent()."\n
		".$this->sajax_dynamic_js().'
		//-->
		</script>';
	
		echo $header;
	
	}

	/**
	*	parse data function
	*	@return array
	*/
	function parse_data($data)
	{
		$containers = explode(":", $data);
	  	foreach($containers AS $container)
  		{
      		$container = str_replace(")", "", $container);
      		$i = 0;
			$lastly = explode("(", $container);
      		$values = explode(",", $lastly[1]);
      		foreach($values AS $value)
      		{
        		if($value == '')
        		{
            		continue;
        		}
        		$final[$lastly[0]][] = $value;
        		$i+=2;
      		}
  		}
    	return $final;
	}

	/**
	*	update the database
	*	@return integer
	*/
	function update_db($data_array)
	{
		global $cfg;

	  	foreach($data_array AS $set => $items)
	  	{
	     	$i = 0;
	     	foreach($items AS $item)
	     	{
	       		$item = mysql_escape_string($item);
	       		$set  = mysql_escape_string($set);
	       
	       		mysql_query("UPDATE ".$this->db['table']." 
	       					SET ".$this->db['sidebarfield']." = '$set', 
	       						".$this->db['orderfield']." = '$i'
	       					WHERE ".$this->db['idfield']." = '$item'
	       					LIMIT 1");
	       		$i+=2;
	     	}
	  	}
		return 1;
	}
	
	/**
	* create the js for the lists dynamically, based upon the given lists
	*/
	function sajax_dynamic_js()
	{
		if(!empty($this->lists))
		{
		
		$js[]='
		function sajaxInitOnLoad() {';
		
		$lists=explode(',',$this->lists);
		
		foreach($lists as $list)
		{
		
		$js[]='        
        	list = document.getElementById("'.$list.'");
            DragDrop.makeListContainer( list, \'sidebar\' );
            list.onDragOver = function() { this.style["background"] = "#EEF"; };
            list.onDragOut = function() {this.style["background"] = "none"; };
            list.onDragDrop = function() {onDrop(); };
            ';

		}

		$js[]='               
		};
	
		addLoadEvent(sajaxInitOnLoad);		
		';
		
		}
		
		return trim(join("\n",$js));
		
	}
	
	/**
	*
	*/
	function addOnloadEvent()
	{
	
		return'
		function addLoadEvent(func) {
    	      var oldonload = window.onload;
        	  if (typeof window.onload != \'function\') {
            	window.onload = func;
	          } else {
    	        window.onload = function() {
        	      oldonload();
            	  func();
				}
			}
		}';
	
	}
	
	/**
	* 	handle the client request
	*/
	function sajax_handle_client_request() {
		global $sajax_export_list;
		
		$mode = "";
		
		if (! empty($_GET["rs"])) 
			$mode = "get";
		
		if (!empty($_POST["rs"]))
			$mode = "post";
			
		if (empty($mode)) 
			return;

		if ($mode == "get") {
			// Bust cache in the head
			header ("Expires: Mon, 26 Jul 1997 05:00:00 GMT");    // Date in the past
			header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
			// always modified
			header ("Cache-Control: no-cache, must-revalidate");  // HTTP/1.1
			header ("Pragma: no-cache");                          // HTTP/1.0
			$func_name = $_GET["rs"];
			if (! empty($_GET["rsargs"])) 
				$args = $_GET["rsargs"];
			else
				$args = array();
		}
		else {
			$func_name = $_POST["rs"];
			if (! empty($_POST["rsargs"])) 
				$args = $_POST["rsargs"];
			else
				$args = array();
		}
		
		if (! in_array($func_name, $this->sajax_export_list))
			echo "-:$func_name not callable";
		else {
			echo "+:";
			$result = call_user_func_array(array(&$this, $func_name), $args);
			echo $result;
		}
		exit;
	}
	
	/**
	*	get the necessary js for sajax
	*	@return string returns the javascript
	*/
	function sajax_get_common_js() {
		
		$t = strtoupper($this->sajax_request_type);
		if ($t != "GET" && $t != "POST") 
			return "// Invalid type: $t.. \n\n";
			
		if($this->sajax_debug_mode)
		{
			$debug="true";
		} else {
			$debug="false";
		}
		
		$js='
		// remote scripting library
		// (c) copyright 2005 modernmethod, inc
		var sajax_debug_mode = '.$debug.';
		var sajax_request_type = "'.$t.'";
		
		function sajax_debug(text) {
			if (sajax_debug_mode)
				alert("RSD: " + text)
		}
 		function sajax_init_object() {
 			sajax_debug("sajax_init_object() called..")
 			
 			var A;
			try {
				A=new ActiveXObject("Msxml2.XMLHTTP");
			} catch (e) {
				try {
					A=new ActiveXObject("Microsoft.XMLHTTP");
				} catch (oc) {
					A=null;
				}
			}
			if(!A && typeof XMLHttpRequest != "undefined")
				A = new XMLHttpRequest();
			if (!A)
				sajax_debug("Could not create connection object.");
			return A;
		}
		function sajax_do_call(func_name, args) {
			var i, x, n;
			var uri;
			var post_data;
			
			uri = "'.$this->sajax_remote_uri.'";
			if (sajax_request_type == "GET") {
				if (uri.indexOf("?") == -1) 
					uri = uri + "?rs=" + escape(func_name);
				else
					uri = uri + "&rs=" + escape(func_name);
				for (i = 0; i < args.length-1; i++) 
					uri = uri + "&rsargs[]=" + escape(args[i]);
				uri = uri + "&rsrnd=" + new Date().getTime();
				post_data = null;
			} else {
				post_data = "rs=" + escape(func_name);
				for (i = 0; i < args.length-1; i++) 
					post_data = post_data + "&rsargs[]=" + escape(args[i]);
			}
			
			x = sajax_init_object();
			x.open(sajax_request_type, uri, true);
			if (sajax_request_type == "POST") {
				x.setRequestHeader("Method", "POST " + uri + " HTTP/1.1");
				x.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			}
			x.onreadystatechange = function() {
				if (x.readyState != 4) 
					return;
				sajax_debug("received " + x.responseText);
				
				var status;
				var data;
				status = x.responseText.charAt(0);
				data = x.responseText.substring(2);
				if (status == "-") 
					alert("Error: " + data);
				else  
					args[args.length-1](data);
			}
			x.send(post_data);
			sajax_debug(func_name + " uri = " + uri + "/post = " + post_data);
			sajax_debug(func_name + " waiting..");
			delete x;
		}';
		return $js;
	}
	
	/**
	*	show the common javascript
	*/
	function sajax_show_common_js() {
		echo $this->sajax_get_common_js();
	}	
	
	/**
	*	escape value
	*	@return string
	*/
	function sajax_esc($val)
	{
		return str_replace('"', '\\\\"', $val);
	}	
	
	/**
	*	sajax get one stub 
	*	@return string
	*/
	function sajax_get_one_stub($func_name) {

		$html='
		// wrapper for <'.$func_name.'
		
		function x_'.$func_name.'() {
			sajax_do_call("'.$func_name.'",
				x_'.$func_name.'.arguments);
		}';

		return $html;
	}	
	
	/**
	*	show the stub ;)
	*/
	function sajax_show_one_stub($func_name) {
		echo $this->sajax_get_one_stub($func_name);
	}	
	
	/**
	*	sajax export
	*/
	function sajax_export() {
		$n = func_num_args();
		for ($i = 0; $i < $n; $i++) {
			$this->sajax_export_list[] = func_get_arg($i);
		}
	}	
	
	/**
	*	sajax prepare the js
	*/
	function sajax_get_javascript()
	{
		global $sajax_js_has_been_shown;
		global $sajax_export_list;
		
		$html = "";
		if (! $this->sajax_js_has_been_shown) {
			$html .= $this->sajax_get_common_js();
			$this->sajax_js_has_been_shown = 1;
		}
		foreach ($this->sajax_export_list as $func) {
			$html .= $this->sajax_get_one_stub($func);
		}
		return $html;
	}
	/**
	*	sajax show the javascript
	*/
	function sajax_show_javascript()
	{
		echo $this->sajax_get_javascript();
	}
	
	/**
	*	sajax update
	*/
	function sajax_update($data)
	{
	  $data = $this->parse_data($data);
	  $this->update_db($data);
	  return 'y';
	}		
}

